/*
	ekses1() - draws X's with top/bottom sections in solid color
	ekses2() - draws X's with left/right sections in solid color
*/

#include <stdlib.h>
#include <graphics.h>

extern	step,
	newfill(int);


int ekses1(int x1,int y1,int x2,int y2)
{
  struct pixel
  {
    int x, y;
  } tri[4];
  int	minx=min(x1,x2),
	miny=min(y1,y2),
	maxx=max(x1,x2),
	maxy=max(y1,y2),
	midx=(x1+x2)>>1,
	midy=(y1+y2)>>1,
	w=(maxx-minx)>>2;

  if((maxx-minx)<5)
    return;
  if((maxy-miny)<5)
    return;
  newfill(step);

  tri[0].x=midx;	tri[0].y=midy;
  tri[3].x=midx;	tri[3].y=midy;

  tri[1].x=minx;	tri[1].y=miny;
  tri[2].x=minx+w;	tri[2].y=miny;
  fillpoly(4,(int far *)tri);

  tri[1].x=maxx;	tri[1].y=miny;
  tri[2].x=maxx-w;	tri[2].y=miny;
  fillpoly(4,(int far *)tri);

  tri[1].x=maxx;	tri[1].y=maxy;
  tri[2].x=maxx-w;	tri[2].y=maxy;
  fillpoly(4,(int far *)tri);

  tri[1].x=minx;	tri[1].y=maxy;
  tri[2].x=minx+w;	tri[2].y=maxy;
  fillpoly(4,(int far *)tri);
}


int ekses2(int x1,int y1,int x2,int y2)
{
  struct pixel{
    int x, y;
  } tri[4];
  int	minx=min(x1,x2),
	miny=min(y1,y2),
	maxx=max(x1,x2),
	maxy=max(y1,y2),
	midx=(x1+x2)>>1,
	midy=(y1+y2)>>1,
	h=(maxy-miny)>>2;

  if((maxx-minx)<5)
    return;
  if((maxy-miny)<5)
    return;
  newfill(step);

  tri[0].x=midx;	tri[0].y=midy;
  tri[3].x=midx;	tri[3].y=midy;

  tri[1].x=minx;	tri[1].y=miny;
  tri[2].x=minx;	tri[2].y=miny+h;
  fillpoly(4,(int far *)tri);

  tri[1].x=maxx;	tri[1].y=miny;
  tri[2].x=maxx;	tri[2].y=miny+h;
  fillpoly(4,(int far *)tri);

  tri[1].x=maxx;	tri[1].y=maxy;
  tri[2].x=maxx;	tri[2].y=maxy-h;
  fillpoly(4,(int far *)tri);

  tri[1].x=minx;	tri[1].y=maxy;
  tri[2].x=minx;	tri[2].y=maxy-h;
  fillpoly(4,(int far *)tri);
}

