/*
	ISVGA.C - Determines if video system can do VGA.
	gjpateman 2/5/91
*/

#pragma inline	/* tell compiler that this file contains asm statements */

int isvga(void)
{
  unsigned char result;

  asm {
    mov ah,0x1A		/* Get/set display combination code */
    xor al,al		/* get code ("xor al,al" is faster than "mov al,0" */
    int 0x10		/* video interrupt */
    mov [result],bl
  }
  return((result==8)||(result==7));	/* 8==color VGA, 7==mono VGA */
}
