/*
	bar1() - draws solid rectangles w/various fill patterns.
*/

#include <graphics.h>
#include <stdlib.h>

extern	step,
	newfill(int);

int bar1(int x1,int y1,int x2,int y2)
{
  newfill(step);
  bar(min(x1,x2),min(y1,y2),max(x1,x2),max(y1,y2));
}


int bar2(int x1,int y1,int x2,int y2)
{
  int	minx=min(x1,x2),
	miny=min(y1,y2),
	maxx=max(x1,x2),
	maxy=max(y1,y2),
	midx=(minx+maxx)/2,
	midy=(miny+maxy)/2;

  newfill(step);
  rectangle(minx,miny,midx,midy);
  rectangle(midx,miny,maxx,midy);
  rectangle(minx,midy,midx,maxy);
  rectangle(midx,midy,maxx,maxy);
}
