/*
	stars1() - draws flowers/stars/etc (variations on circles)
	Non-BGI function
*/

#include <graphics.h>
#include <math.h>
#include <conio.h>

extern	step,
	keyhit(void);

int stars1(int x1,int y1,int x2,int y2,float randomfloat)
{
  int	midx=(x1+x2)>>1,
	midy=(y1+y2)>>1,
	col=getcolor();
  float	angle,
	radius,
	sina,cosa,
	anglestart=0,
	anglestep=M_PI_2/3.0,
	angleend=M_PI;

  for(radius=step*5;radius>=0;radius-=0.5)
  {
    for(angle=anglestart;angle<=angleend;angle+=anglestep)
    {
      if(kbhit())
	keyhit();
      sina=radius*sin(angle);
      cosa=radius*cos(angle);
      putpixel(midx+sina,midy+cosa,col);
      putpixel(midx-sina,midy+cosa,col);
      putpixel(midx-sina,midy-cosa,col);
      putpixel(midx+sina,midy-cosa,col);
    }
    anglestart+=(anglestep/randomfloat);
    angleend+=(anglestep/randomfloat);
  }
}
